#define BIT00 1
#define BIT01 2
#define BIT02 4
#define BIT03 8
#define BIT04 16
#define BIT05 32
#define BIT06 64
#define BIT07 128
#define BIT08 256
#define BIT09 512
#define BIT10 1024
#define BIT11 2048
#define BIT12 4096
#define BIT13 8192
#define BIT14 16384
#define BIT15 32768

#define DISPCNT		*(u16*)0x04000000			//Sets DISPCNT to be the register for it.  Easier than using the hex every time
#define BG0CNT		*(u16*)0x04000008			//Sets BG0CNT to be the register for it.  Easier than using the hex every time
#define BG0HOFS		*(u16*)0x04000010
#define BG0VOFS		*(u16*)0x04000012
#define BG1CNT		*(u16*)0x0400000A			//Sets BG0CNT to be the register for it.  Easier than using the hex every time
#define BG1HOFS		*(u16*)0x04000014
#define BG1VOFS		*(u16*)0x04000016
#define BG2CNT		*(u16*)0x0400000C			//Sets BG0CNT to be the register for it.  Easier than using the hex every time
#define BG2HOFS		*(u16*)0x04000018
#define BG2VOFS		*(u16*)0x0400001A
#define P1        	*(u16*)0x04000130

#define DMA3SAD		*(u32*)0x040000d4
#define DMA3DAD		*(u32*)0x040000d8
#define DMA3CNT		*(u32*)0x040000dc
#define OAM			((Sprite*)0x07000000)
#define OBJCHARDATA	((u8*)0x06010000)
#define BGCHARDATA	((u8*)0x06004000)
#define OBJ_PLTT	((u16*)0x05000200)
#define BG_PLTT		((u16*)0x05000000)

typedef unsigned char u8;						//some type definitions
typedef signed char s8;
typedef unsigned short u16;
typedef signed short s16;
typedef unsigned long u32;

typedef struct _Sprite { u16 Attrib0, Attrib1, Attrib2, RotateScale; } Sprite;		//define a sprite as a structure

extern u8 pic;									//adds the pic and palette from data.asm
extern u16 pal;

u16 *m0=(u16*)0x6000000;						//tells the compiler when our bkg map is going to be located
u16 *m1=(u16*)0x6001000;
u16 *m2=(u16*)0x6002000;

u16 bghofs = 0xFFC0;
u16 bgvofs = 64;
u8 plyX = 1;
u8 plyY = 1;

u8 MapE0[27][50];
u8 MapE1[27][50];
u8 MapE2[27][50];

u8 MapC[9][16] = {{ 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7},
				  { 7, 0, 0, 0, 0, 0, 0, 7, 5, 5, 5, 0, 1, 7, 1, 7},
				  { 7, 0, 8, 0, 8, 0, 8, 5, 7, 5, 1, 0, 0, 7, 5, 7},
				  { 7, 0, 0, 0, 7, 0, 0, 0, 0, 5, 7, 7, 7, 7, 0, 7},
				  { 7, 0, 7, 0, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 7},
				  { 7, 5, 7, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 0, 0, 7},
				  { 7, 1, 7, 0, 8, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 7},
				  { 7, 1, 7, 0, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 7},
				  { 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7}};

void DMA3Call(u32 Src,u32 Dst,u32 Cnt)	//used to load our sprite info into vram			
{
	DMA3SAD = Src;						//where the data is
	DMA3DAD = Dst;						//where the data goes
	DMA3CNT = Cnt;						//how much data should be loaded
}

void MakeBKG()
{
	s16 x,y;								//define some temp variables
	s8 xA,yA;

	x=30;
	y=1;
	for(xA=15;xA>=-1;xA--) {
		for(yA=0;yA<10;yA++) {
			if(MapC[yA][xA]!=5 && MapC[yA][xA]!=7) {
				if(yA==0) {
					if(xA!=-1) {
						MapE2[y][x]=4;
						MapE2[y][x+1]=5;
					}
				}
				else if(MapC[yA-1][xA]!=5 && MapC[yA-1][xA]!=7) {
					if(xA==-1) {
						if(MapC[yA-1][xA+1]!=5) {
							MapE2[y][x]=12;
							MapE2[y][x+1]=13;
						}
					}
					else if(yA==9) {
						MapE2[y][x]=10;
						MapE2[y][x+1]=11;
					}						
					else {
						MapE2[y][x]=2;
						MapE2[y][x+1]=3;
					}
				}
				if(MapC[yA][xA+1]!=5 && MapC[yA][xA+1]!=7) {
					if(xA==15) {
						if(yA!=9) {
							MapE2[y][x+2]=6;
							MapE2[y][x+3]=7;
						}
					}
					else if(yA==9) {
						if(MapC[yA-1][xA+1]!=5) {
							MapE2[y][x+2]=14;
							MapE2[y][x+3]=15;
						}
					}
					else if(xA==-1) {
						MapE2[y][x+2]=8;
						MapE2[y][x+3]=9;
					}
					else {
						MapE2[y][x+2]=2;
						MapE2[y][x+3]=3;
					}
				}
				if(xA==15 && yA!=9 && MapC[yA][xA]!=5) {
					MapE2[y][x+2]=6;
					MapE2[y][x+3]=7;
				}
			}
			else if(MapC[yA][xA]==5) {
				if(MapC[yA][xA-1]!=5 && MapC[yA][xA-1]!=7 && xA>0) {
					MapE1[y+1][x]=6;
					MapE1[y+1][x+1]=7;
				}
				if(MapC[yA-1][xA]!=5 && yA!=0 && xA!=-1) {
					if(MapC[yA-1][xA]!=7) {
						MapE2[y][x]=10;
						MapE2[y][x+1]=11;
					}
					MapE2[y+1][x]=14;
					MapE2[y+1][x+1]=15;
				}
				if(MapC[yA][xA+1]!=5 && xA!=15 && yA!=9) {
					if(MapC[yA][xA+1]!=7) {
						MapE2[y][x+2]=8;
						MapE2[y][x+3]=9;
					}
					MapE2[y+1][x+2]=12;
					MapE2[y+1][x+3]=13;
				}
				if(MapC[yA+1][xA]!=5 && MapC[yA+1][xA]!=7 && yA!=8 && xA!=-1) {
					MapE1[y+1][x+2]=4;
					MapE1[y+1][x+3]=5;
				}
			}
			else if(MapC[yA][xA]==7) {
				if((MapC[yA][xA-1]==5 || xA==0) && xA!=-1) {
					MapE2[y+1][x]=16;
					MapE2[y+1][x+1]=17;
				}
				else if(xA!=-1) {
					MapE2[y+1][x]=20;
					MapE2[y+1][x+1]=21;
				}
				if((MapC[yA+1][xA]==5 || yA==8) && xA!=-1) {
					MapE2[y+1][x+2]=18;
					MapE2[y+1][x+3]=19;
				}
				else {
					MapE2[y+1][x+2]=22;
					MapE2[y+1][x+3]=23;
				}
				if(xA!=-1) {
					if(MapC[yA-1][xA]==7) {
						MapE0[y-1][x]=2;
						MapE0[y-1][x+1]=3;
					}
					else {
						MapE0[y-1][x]=4;
						MapE0[y-1][x+1]=5;
					}
					MapE0[y][x]=8;
					MapE0[y][x+1]=9;
					MapE0[y][x+2]=10;
					MapE0[y][x+3]=11;
					if(MapC[yA][xA+1]==7 && xA!=15) {
						MapE0[y-1][x+2]=2;
						MapE0[y-1][x+3]=3;
					}
					else {
						MapE0[y-1][x+2]=6;
						MapE0[y-1][x+3]=7;
					}
				}
			}
			if(yA==9 && MapC[yA-1][xA]!=5) {
					MapE2[y+1][x]=14;
					MapE2[y+1][x+1]=15;
			}
			if(xA==-1 && MapC[yA-1][xA+1]!=5 && yA!=0) {
					MapE2[y][x]=12;
					MapE2[y][x+1]=13;
			}
			if(xA==-1 && MapC[yA][xA+1]==0 && yA!=0 && yA!=9) {
					MapE2[y][x+2]=8;
					MapE2[y][x+3]=9;
			}
			x+=2;
			y+=1;
		}
		x=xA*2-2;
		y=17-xA;
	}

	for (y=0;y<27;y++) 						//loop to load in the map data
		for (x=0;x<32;x++) {
			m0[y*32+x]=MapE0[y][x];
			m1[y*32+x]=MapE1[y][x];
			m2[y*32+x]=MapE2[y][x];
		}
	for (y=0;y<27;y++)
		for (x=32;x<50;x++) {
			m0[y*32+x+0x0400-32]=MapE0[y][x];
			m1[y*32+x+0x0400-32]=MapE1[y][x];
			m2[y*32+x+0x0400-32]=MapE2[y][x];
		}
}

// VSYNC function by Eloist
void WaitForVSync()
{
  __asm
   {
    mov 	r0, #0x4000006
    scanline_wait:
     ldrh	r1, [r0]
     cmp	r1, #160
    bne 	scanline_wait
   }
}

void PlaceSprite(s16 x,s16 y,u16 shape, u16 size, u16 tile, u16 i)			//sets the sprite data at the x and y coordinates and tells what 
{										//tile # to use
	x+=512;
	if(y<0) y+=256;
	OAM[i].Attrib0 = 0x2000+shape+y;	//loads sprite 0 at y coordinate.  the 0x2000 tells it to use a 256 color palette
	OAM[i].Attrib1 = size+x;			//loads sprite 0 at x coordinate
	OAM[i].Attrib2 = tile;				//sets up sprite tile #
}

void DrawSprites()
{
	u8 x,y,i=0;

	while(OAM[i].Attrib2!=0) {
		OAM[i].Attrib0=0;
		i++;
	}

	i=0;
	for(y=0;y<9;y++)
		for(x=0;x<16;x++) {
			if(MapC[y][x]==1) {
				PlaceSprite(x*16+y*16+8-bghofs,y*8+x*-8+132-bgvofs,0x4000,0,0x0458, i);
				i++;
			}
			else if(MapC[y][x]==2) {
				PlaceSprite(x*16+y*16+8-bghofs,y*8+x*-8+132-bgvofs,0x4000,0,0x0434, i);
				i++;
			}
			else if(MapC[y][x]==3) {
				PlaceSprite(x*16+y*16+8-bghofs,y*8+x*-8+132-bgvofs,0x4000,0,0x0430, i);
				i++;
			}
			else if(MapC[y][x]==4) {
				PlaceSprite(x*16+y*16+8-bghofs,y*8+x*-8+132-bgvofs,0x4000,0,0x045C, i);
				i++;
			}
			else if(MapC[y][x]==8) {
				PlaceSprite(x*16+y*16-bghofs,y*8+x*-8+120-bgvofs,0,0x8000,0x0438, i);
				i++;
			}
		}
}

void Init()
{
	BG0CNT = 0x4084;							//turn on BG0CNT.  Also tells where the map and tile locations are for this bkg
	BG1CNT = 0x4285;							//turn on BG0CNT.  Also tells where the map and tile locations are for this bkg
	BG2CNT = 0x4486;							//turn on BG0CNT.  Also tells where the map and tile locations are for this bkg
	DISPCNT = 0x1760;

	DMA3Call((u32)&pal, (u32)OBJ_PLTT, 0x84000080);				// Setup the sprites palette
	DMA3Call((u32)&pal, (u32)BG_PLTT, 0x84000080);				// Setup the background palette
	DMA3Call((u32)&pic, (u32)OBJCHARDATA, 0x84000000+64*52);	// Copy Sprites Character Bloc to VRAM
	DMA3Call((u32)&pic, (u32)BGCHARDATA, 0x84000000+64*52);		// Copy Background Character Bloc into VRAM
}

void UpdateScroll() {
	WaitForVSync();
	BG0HOFS=bghofs;
	BG1HOFS=bghofs;
	BG2HOFS=bghofs;
	BG0VOFS=bgvofs; 
	BG1VOFS=bgvofs; 
	BG2VOFS=bgvofs; 
	DrawSprites();
}

void UpdatePlayer(u8 shift) {
	u8 i=0;
	while(OAM[i].Attrib0!=0) i++;
	PlaceSprite(plyX*16+plyY*16+8-bghofs+(bghofs & 15),plyY*8+plyX*-8+132-bgvofs+(bgvofs & 7)-shift*8,0x4000,0,0x0460, i);
}

void C_Entry()
{
	u8 i;

	Init();										//call init to set up our screen display
	MakeBKG();									//display the background
	UpdateScroll();
	UpdatePlayer(0);
	while (1)
	{
		if(!(P1 & BIT04)) {
			if(MapC[plyY+1][plyX]==0) {
				for(i=0;i<8;i++) {
					bghofs+=2;
					bgvofs+=1;
					if(i<7) {UpdateScroll(); UpdatePlayer(0);}
				}
				plyY++;
				UpdateScroll();
				UpdatePlayer(0);
			}
			else if(!(P1 & BIT00) && MapC[plyY+1][plyX]==8) {
				i=2;
				while(MapC[plyY+i][plyX]==0) {
					MapC[plyY+i-1][plyX]=0;
					MapC[plyY+i][plyX]=8;
					UpdateScroll();
					UpdatePlayer(0);
					i++;
				}
				P1 |=BIT00;
			}
			P1 |=BIT04;
		}
		else if(!(P1 & BIT05)) {
			if(MapC[plyY-1][plyX]==0) {
				plyY--;
				for(i=0;i<8;i++) {
					bghofs-=2;
					bgvofs-=1;
					UpdateScroll();
					UpdatePlayer(0);
				}
				UpdateScroll();
				UpdatePlayer(0);
			}
			else if(!(P1 & BIT00) && MapC[plyY-1][plyX]==8) {
				i=2;
				while(MapC[plyY-i][plyX]==0) {
					MapC[plyY-i+1][plyX]=0;
					MapC[plyY-i][plyX]=8;
					UpdateScroll();
					UpdatePlayer(0);
					i++;
				}
				P1 |=BIT00;
			}
			P1 |=BIT05;
		}
		else if(!(P1 & BIT06)) {
			if(MapC[plyY][plyX+1]==0) {
				for(i=0;i<8;i++) {
					bghofs+=2;
					bgvofs-=1;
					if(i<7) {UpdateScroll(); UpdatePlayer(1);}
				}
				plyX++;
				UpdateScroll();
				UpdatePlayer(0);
			}
			else if(!(P1 & BIT00) && MapC[plyY][plyX+1]==8) {
				i=2;
				while(MapC[plyY][plyX+i]==0) {
					MapC[plyY][plyX+i-1]=0;
					MapC[plyY][plyX+i]=8;
					UpdateScroll();
					UpdatePlayer(0);
					i++;
				}
				P1 |=BIT00;
			}
			P1 |=BIT06;
		}
		else if(!(P1 & BIT07)) {
			if(MapC[plyY][plyX-1]==0) {
				plyX--;
				for(i=0;i<8;i++) {
					bghofs-=2;
					bgvofs+=1;
					if(i<7) {UpdateScroll(); UpdatePlayer(1);}
				}
				UpdateScroll();
				UpdatePlayer(0);
			}
			else if(!(P1 & BIT00) && MapC[plyY][plyX-1]==8) {
				i=2;
				while(MapC[plyY][plyX-i]==0) {
					MapC[plyY][plyX-i+1]=0;
				//	MapC[plyY][plyX-i]=8;
					UpdateScroll();
					UpdatePlayer(0);
					i++;
				}
				P1 |=BIT00;
			}
			P1 |=BIT07;
		}
	}
}

//void GetKeys()
//{
  // Note that I reset the bit after checking weather the key was pressed. See the 
  // Programming Matters section in the readme.
//  if( !(P1 & BIT00) ) { Greetings = 1;  P1 |= BIT00; }   // "A" button
//  if( !(P1 & BIT01) ) { Greetings = 2;  P1 |= BIT01; }   // "B" button
//  if( !(P1 & BIT02) ) { Greetings = 3;  P1 |= BIT02; }   // "Select" button
//  if( !(P1 & BIT03) ) { Greetings = 4;  P1 |= BIT03; }   // "Start" button 
//  if( !(P1 & BIT04) ) { Greetings = 8;  P1 |= BIT04; }   // Right-Direction
//  if( !(P1 & BIT05) ) { Greetings = 7;  P1 |= BIT05; }   // Left-Direction
//  if( !(P1 & BIT06) ) { Greetings = 5;  P1 |= BIT06; }   // Up-Direction
//  if( !(P1 & BIT07) ) { Greetings = 6;  P1 |= BIT07; }   // Down-Direction
//  if( !(P1 & BIT08) ) { Greetings = 10; P1 |= BIT08; }  // "R" button
//  if( !(P1 & BIT09) ) { Greetings = 9;  P1 |= BIT09; }  // "L" button
//}